<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Oboružani s ova dva algoritma, možemo doći do Bresenhamovog algoritma s decimalnim brojevima na sljedeći način.</p>

<p>Algoritmi koje smo do sada izložili dobro će nacrtati liniju ako je kut linije i pozitivne osi X između plus-minus 45° (<code>drawLineX</code>) odnosno ako je kut linije i pozitivne osi Y između plus-minus 45° (<code>drawLineY</code>). Promotrimo koji su sve slučajevi mogući. Na slici u nastavku ilustrirano je 8 linija pri čemu je naznačeno koja je točka početna a koja završna; svaka je primjer jednog scenarija koji moramo razmotriti. Koordinatni sustav je matematički. Apscisa pri tome odgovara vrijednosti \(dx=x_1-x_0\) a ordinata vrijednosti \(dy=y_1-y_0\).</p>

<figure class="mlFigure">
<img src="@#file#(slucajevi.svg)" alt="8 različitih scenarija pri crtanju linije"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> 8 različitih scenarija pri crtanju linije.</figcaption>
</figure>

<p>Primjerice, slučaj 1 odgovara liniji zadanoj tako da je početna točka lijevija od završne (\(dx>0\)) i niže od završne (\(dy>0\)). Dodatno, \(dx &gt; dy\): veća je promjena po x-u nego po y-u pa je kut između 0° i 45°.</p>

<p>Što napraviti u svakom od navedenih slučajeva?</p>

<ul>
<li><span style="font-weight: bold;">Slučaj 1.</span> Crtamo s <code>drawLineX</code> i predajemo točke baš kako su zadane.</li>
<li><span style="font-weight: bold;">Slučaj 8.</span> Crtamo s <code>drawLineX</code> i predajemo točke baš kako su zadane.</li>
<li><span style="font-weight: bold;">Slučaj 2.</span> Crtamo s <code>drawLineY</code> i predajemo točke baš kako su zadane.</li>
<li><span style="font-weight: bold;">Slučaj 3.</span> Crtamo s <code>drawLineY</code> i predajemo točke baš kako su zadane.</li>
<li><span style="font-weight: bold;">Slučaj 4.</span> Svodimo na slučaj 8 time što zamijenimo početnu i konačnu točku; crtamo s <code>drawLineX</code> i predajemo točke obrnutim redoslijedom.</li>
<li><span style="font-weight: bold;">Slučaj 5.</span> Svodimo na slučaj 1 time što zamijenimo početnu i konačnu točku; crtamo s <code>drawLineX</code> i predajemo točke obrnutim redoslijedom.</li>
<li><span style="font-weight: bold;">Slučaj 6.</span> Svodimo na slučaj 2 time što zamijenimo početnu i konačnu točku; crtamo s <code>drawLineY</code> i predajemo točke obrnutim redoslijedom.</li>
<li><span style="font-weight: bold;">Slučaj 7.</span> Svodimo na slučaj 3 time što zamijenimo početnu i konačnu točku; crtamo s <code>drawLineY</code> i predajemo točke obrnutim redoslijedom.</li>
</ul>

<p>U konačnici, to bi izgledalo ovako.</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  double dx = xe-xs;
  double dy = ye-ys;
  if(abs(dx) &gt;= abs(dy)) { // nagib prema apscisi je manji
    if(dx>=0) {
      drawLineX(xs, ys, xe, ye); // x-evi rastu uzduž linije
    } else {
      drawLineX(xe, ye, xs, ys); // zamijeni točke pa će x-evi opet rasti uzduž linije
    }
  } else { // nagib prema ordinati je manji
    if(dy &gt;= 0) {
      drawLineY(xs, ys, xe, ye); // y-oni rastu uzduž linije
    } else {
      drawLineY(xe, ye, xs, ys); // zamijeni točke pa će y-oni opet rasti uzduž linije
    }
  }
}
</pre>

<p>Isprobajte algoritam!</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas5" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData5 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas5 = new RasterDisplay("myCanvas5", 20, 20);
    var alg5 = new BresenhamAlgorithm6(lineData5, brcanvas5);
    brcanvas5.idealLineData = lineData5;
    brcanvas5.paint();
  </script>
  drawLine(<input type="text" id="line5_x0" value="1" size="2">, <input type="text" id="line5_y0" value="1" size="2">, <input type="text" id="line5_x1" value="17" size="2">, <input type="text" id="line5_y1" value="8" size="2">)
  <button onclick="if(parseLineData('line5',lineData5)) {alg5.reset(); document.getElementById('alg5btn').disabled=false;}">Postavi</button><br>
  <button onclick="alg5.reset(); document.getElementById('alg5btn').disabled=false;">Reset</button>
  <button id="alg5btn" onclick="alg5.next(); if(!alg5.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg5ch1" type="checkbox" onclick="brcanvas5.showIdealLine = document.getElementById('alg5ch1').checked ? true : false; brcanvas5.paint();"> Prikaz idealne linije

<p>Umjesto prikazanog algoritma <code>drawLineY</code>, mogli smo pripremiti inačicu koja radi korektno kada y-i rastu ili padaju, ali uz rast x-koordinata (na slici 1, to bi bili slučajevi 2 i 7). U tom slučaju, konačni algoritam koji izvođenje delegira jednoj od njih najprije bi ispitao da li x-evi rastu ili ne (ako ne, radio bi zamjenu točaka), a unutar toga, ispitali bismo je li linija nagibom bliža apscisi ili ordinati i na temelju toga pozvali pravu funkciju. Osnovnim funkcijama tada bi bili pokriveni slučajevi 1, 2, 7 i 8; slučaj 3 preveli bismo u 7, slučaj 4 u 8, slučaj 5 u 1 a slučaj 6 u 2. Takav postupak prikazan je u knjizi (Čupić, Mihajlović: Interaktivna računalna grafika
kroz primjere u OpenGL-u).</p>

<p>Kao posljednji korak u ubrzanju rada algoritma (što dalje jest osnova za stvarne implementacije u grafičkom sklopovlju) potrebno je u cijelosti se riješiti decimalnih brojeva. To je moguće učiniti vrlo jednostavno, a zainteresiranog čitatelja za više detalja upućujemo na spomenutu knjigu.</p> 

